// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITCONFIGITERATOR_H
#define GITCONFIGITERATOR_H
#include <nan.h>
#include <string>
#include <utility>
#include <sstream>

#include "async_baton.h"
#include "async_worker.h"
#include "cleanup_handle.h"
#include "context.h"
#include "lock_master.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"

#include "../include/config.h"
#include "../include/config_entry.h"
// Forward declaration.
struct git_config_iterator {
};

using namespace node;
using namespace v8;

class GitConfigIterator;
 
struct GitConfigIteratorTraits {
  typedef GitConfigIterator cppClass;
  typedef git_config_iterator cType;
 
  static const bool isDuplicable = false;
  static void duplicate(git_config_iterator **dest, git_config_iterator *src) {
     Nan::ThrowError("duplicate called on GitConfigIterator which cannot be duplicated");
   }

  static std::string className() { return "GitConfigIterator"; };
  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_config_iterator *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::git_config_iterator_free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitConfigIterator : public
  NodeGitWrapper<GitConfigIteratorTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitConfigIteratorTraits>;
   public:
    GitConfigIterator(const GitConfigIterator &) = delete;
    GitConfigIterator(GitConfigIterator &&) = delete;
    GitConfigIterator &operator=(const GitConfigIterator &) = delete;
    GitConfigIterator &operator=(GitConfigIterator &&) = delete;

    static void InitializeComponent (v8::Local<v8::Object> target, nodegit::Context *nodegitContext);

                    

  private:
    GitConfigIterator()
      : NodeGitWrapper<GitConfigIteratorTraits>(
           "A new GitConfigIterator cannot be instantiated."
       )
    {}
    GitConfigIterator(git_config_iterator *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitConfigIteratorTraits>(raw, selfFreeing, owner)
    {}
    ~GitConfigIterator();

    struct CreateBaton {
      int error_code;
      const git_error* error;
      git_config_iterator * out;
      const git_config * cfg;
     };
    class CreateWorker : public nodegit::AsyncWorker {
      public:
        CreateWorker(
            CreateBaton *_baton,
            Nan::Callback *callback,
            std::map<std::string, std::shared_ptr<nodegit::CleanupHandle>> &cleanupHandles
        ) : nodegit::AsyncWorker(callback, "nodegit:AsyncWorker:GitConfigIterator:Create", cleanupHandles)
          , baton(_baton) {};
        CreateWorker(const CreateWorker &) = delete;
        CreateWorker(CreateWorker &&) = delete;
        CreateWorker &operator=(const CreateWorker &) = delete;
        CreateWorker &operator=(CreateWorker &&) = delete;
        ~CreateWorker() {};
        void Execute();
        void HandleErrorCallback();
        void HandleOKCallback();
        nodegit::LockMaster AcquireLocks();

      private:
        CreateBaton *baton;
    };

    static NAN_METHOD(Create);

    struct GlobNewBaton {
      int error_code;
      const git_error* error;
      git_config_iterator * out;
      const git_config * cfg;
      const char * regexp;
     };
    class GlobNewWorker : public nodegit::AsyncWorker {
      public:
        GlobNewWorker(
            GlobNewBaton *_baton,
            Nan::Callback *callback,
            std::map<std::string, std::shared_ptr<nodegit::CleanupHandle>> &cleanupHandles
        ) : nodegit::AsyncWorker(callback, "nodegit:AsyncWorker:GitConfigIterator:GlobNew", cleanupHandles)
          , baton(_baton) {};
        GlobNewWorker(const GlobNewWorker &) = delete;
        GlobNewWorker(GlobNewWorker &&) = delete;
        GlobNewWorker &operator=(const GlobNewWorker &) = delete;
        GlobNewWorker &operator=(GlobNewWorker &&) = delete;
        ~GlobNewWorker() {};
        void Execute();
        void HandleErrorCallback();
        void HandleOKCallback();
        nodegit::LockMaster AcquireLocks();

      private:
        GlobNewBaton *baton;
    };

    static NAN_METHOD(GlobNew);

    struct GitConfigMultivarIteratorNewBaton {
      int error_code;
      const git_error* error;
      git_config_iterator * out;
      const git_config * cfg;
      const char * name;
      const char * regexp;
     };
    class GitConfigMultivarIteratorNewWorker : public nodegit::AsyncWorker {
      public:
        GitConfigMultivarIteratorNewWorker(
            GitConfigMultivarIteratorNewBaton *_baton,
            Nan::Callback *callback,
            std::map<std::string, std::shared_ptr<nodegit::CleanupHandle>> &cleanupHandles
        ) : nodegit::AsyncWorker(callback, "nodegit:AsyncWorker:GitConfigIterator:GitConfigMultivarIteratorNew", cleanupHandles)
          , baton(_baton) {};
        GitConfigMultivarIteratorNewWorker(const GitConfigMultivarIteratorNewWorker &) = delete;
        GitConfigMultivarIteratorNewWorker(GitConfigMultivarIteratorNewWorker &&) = delete;
        GitConfigMultivarIteratorNewWorker &operator=(const GitConfigMultivarIteratorNewWorker &) = delete;
        GitConfigMultivarIteratorNewWorker &operator=(GitConfigMultivarIteratorNewWorker &&) = delete;
        ~GitConfigMultivarIteratorNewWorker() {};
        void Execute();
        void HandleErrorCallback();
        void HandleOKCallback();
        nodegit::LockMaster AcquireLocks();

      private:
        GitConfigMultivarIteratorNewBaton *baton;
    };

    static NAN_METHOD(GitConfigMultivarIteratorNew);

    static NAN_METHOD(GitConfigNext);
};

#endif
