// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITHASHSIG_H
#define GITHASHSIG_H
#include <nan.h>
#include <string>
#include <utility>
#include <sstream>

#include "async_baton.h"
#include "async_worker.h"
#include "cleanup_handle.h"
#include "context.h"
#include "lock_master.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"

extern "C" {
#include <git2.h>
#include <git2/sys/hashsig.h>
}

#include "../include/typedefs.h"


using namespace node;
using namespace v8;

class GitHashsig;
 
struct GitHashsigTraits {
  typedef GitHashsig cppClass;
  typedef git_hashsig cType;
 
  static const bool isDuplicable = false;
  static void duplicate(git_hashsig **dest, git_hashsig *src) {
     Nan::ThrowError("duplicate called on GitHashsig which cannot be duplicated");
   }

  static std::string className() { return "GitHashsig"; };
  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_hashsig *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::git_hashsig_free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitHashsig : public
  NodeGitWrapper<GitHashsigTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitHashsigTraits>;
   public:
    GitHashsig(const GitHashsig &) = delete;
    GitHashsig(GitHashsig &&) = delete;
    GitHashsig &operator=(const GitHashsig &) = delete;
    GitHashsig &operator=(GitHashsig &&) = delete;

    static void InitializeComponent (v8::Local<v8::Object> target, nodegit::Context *nodegitContext);

                

  private:
    GitHashsig()
      : NodeGitWrapper<GitHashsigTraits>(
           "A new GitHashsig cannot be instantiated."
       )
    {}
    GitHashsig(git_hashsig *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitHashsigTraits>(raw, selfFreeing, owner)
    {}
    ~GitHashsig();

    static NAN_METHOD(Compare);

    struct CreateBaton {
      int error_code;
      const git_error* error;
      git_hashsig * out;
      const char * buf;
      size_t buflen;
      git_hashsig_option_t opts;
     };
    class CreateWorker : public nodegit::AsyncWorker {
      public:
        CreateWorker(
            CreateBaton *_baton,
            Nan::Callback *callback,
            std::map<std::string, std::shared_ptr<nodegit::CleanupHandle>> &cleanupHandles
        ) : nodegit::AsyncWorker(callback, "nodegit:AsyncWorker:GitHashsig:Create", cleanupHandles)
          , baton(_baton) {};
        CreateWorker(const CreateWorker &) = delete;
        CreateWorker(CreateWorker &&) = delete;
        CreateWorker &operator=(const CreateWorker &) = delete;
        CreateWorker &operator=(CreateWorker &&) = delete;
        ~CreateWorker() {};
        void Execute();
        void HandleErrorCallback();
        void HandleOKCallback();
        nodegit::LockMaster AcquireLocks();

      private:
        CreateBaton *baton;
    };

    static NAN_METHOD(Create);

    struct CreateFromfileBaton {
      int error_code;
      const git_error* error;
      git_hashsig * out;
      const char * path;
      git_hashsig_option_t opts;
     };
    class CreateFromfileWorker : public nodegit::AsyncWorker {
      public:
        CreateFromfileWorker(
            CreateFromfileBaton *_baton,
            Nan::Callback *callback,
            std::map<std::string, std::shared_ptr<nodegit::CleanupHandle>> &cleanupHandles
        ) : nodegit::AsyncWorker(callback, "nodegit:AsyncWorker:GitHashsig:CreateFromfile", cleanupHandles)
          , baton(_baton) {};
        CreateFromfileWorker(const CreateFromfileWorker &) = delete;
        CreateFromfileWorker(CreateFromfileWorker &&) = delete;
        CreateFromfileWorker &operator=(const CreateFromfileWorker &) = delete;
        CreateFromfileWorker &operator=(CreateFromfileWorker &&) = delete;
        ~CreateFromfileWorker() {};
        void Execute();
        void HandleErrorCallback();
        void HandleOKCallback();
        nodegit::LockMaster AcquireLocks();

      private:
        CreateFromfileBaton *baton;
    };

    static NAN_METHOD(CreateFromfile);
};

#endif
