// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITNOTEITERATOR_H
#define GITNOTEITERATOR_H
#include <nan.h>
#include <string>
#include <utility>
#include <sstream>

#include "async_baton.h"
#include "async_worker.h"
#include "cleanup_handle.h"
#include "context.h"
#include "lock_master.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"


using namespace node;
using namespace v8;

class GitNoteIterator;
 
struct GitNoteIteratorTraits {
  typedef GitNoteIterator cppClass;
  typedef git_note_iterator cType;
 
  static const bool isDuplicable = false;
  static void duplicate(git_note_iterator **dest, git_note_iterator *src) {
     Nan::ThrowError("duplicate called on GitNoteIterator which cannot be duplicated");
   }

  static std::string className() { return "GitNoteIterator"; };
  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_note_iterator *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitNoteIterator : public
  NodeGitWrapper<GitNoteIteratorTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitNoteIteratorTraits>;
   public:
    GitNoteIterator(const GitNoteIterator &) = delete;
    GitNoteIterator(GitNoteIterator &&) = delete;
    GitNoteIterator &operator=(const GitNoteIterator &) = delete;
    GitNoteIterator &operator=(GitNoteIterator &&) = delete;

    static void InitializeComponent (v8::Local<v8::Object> target, nodegit::Context *nodegitContext);

 

  private:
    GitNoteIterator()
      : NodeGitWrapper<GitNoteIteratorTraits>(
           "A new GitNoteIterator cannot be instantiated."
       )
    {}
    GitNoteIterator(git_note_iterator *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitNoteIteratorTraits>(raw, selfFreeing, owner)
    {}
    ~GitNoteIterator();
};

#endif
