// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITOIDARRAY_H
#define GITOIDARRAY_H
#include <nan.h>
#include <string>
#include <utility>
#include <sstream>

#include "async_baton.h"
#include "async_worker.h"
#include "cleanup_handle.h"
#include "context.h"
#include "lock_master.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"

#include "../include/oid.h"

using namespace node;
using namespace v8;

class GitOidarray;
 
struct GitOidarrayTraits {
  typedef GitOidarray cppClass;
  typedef git_oidarray cType;
 
  static const bool isDuplicable = false;
  static void duplicate(git_oidarray **dest, git_oidarray *src) {
     Nan::ThrowError("duplicate called on GitOidarray which cannot be duplicated");
   }

  static std::string className() { return "GitOidarray"; };
  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_oidarray *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::git_oidarray_free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitOidarray : public
  NodeGitWrapper<GitOidarrayTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitOidarrayTraits>;
   public:
    GitOidarray(const GitOidarray &) = delete;
    GitOidarray(GitOidarray &&) = delete;
    GitOidarray &operator=(const GitOidarray &) = delete;
    GitOidarray &operator=(GitOidarray &&) = delete;

    static void InitializeComponent (v8::Local<v8::Object> target, nodegit::Context *nodegitContext);

 

  private:
    GitOidarray()
      : NodeGitWrapper<GitOidarrayTraits>(
           "A new GitOidarray cannot be instantiated."
       )
    {}
    GitOidarray(git_oidarray *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitOidarrayTraits>(raw, selfFreeing, owner)
    {}
    ~GitOidarray();
    static NAN_METHOD(Ids);
    static NAN_METHOD(Count);
};

#endif
