// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITREVSPEC_H
#define GITREVSPEC_H
#include <nan.h>
#include <string>
#include <utility>
#include <sstream>

#include "async_baton.h"
#include "async_worker.h"
#include "cleanup_handle.h"
#include "context.h"
#include "lock_master.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"

#include "../include/object.h"

using namespace node;
using namespace v8;

class GitRevspec;
 
struct GitRevspecTraits {
  typedef GitRevspec cppClass;
  typedef git_revspec cType;
 
  static const bool isDuplicable = false;
  static void duplicate(git_revspec **dest, git_revspec *src) {
     Nan::ThrowError("duplicate called on GitRevspec which cannot be duplicated");
   }

  static std::string className() { return "GitRevspec"; };
  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_revspec *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitRevspec : public
  NodeGitWrapper<GitRevspecTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitRevspecTraits>;
   public:
    GitRevspec(const GitRevspec &) = delete;
    GitRevspec(GitRevspec &&) = delete;
    GitRevspec &operator=(const GitRevspec &) = delete;
    GitRevspec &operator=(GitRevspec &&) = delete;

    static void InitializeComponent (v8::Local<v8::Object> target, nodegit::Context *nodegitContext);

 

  private:
    GitRevspec()
      : NodeGitWrapper<GitRevspecTraits>(
           "A new GitRevspec cannot be instantiated."
       )
    {}
    GitRevspec(git_revspec *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitRevspecTraits>(raw, selfFreeing, owner)
    {}
    ~GitRevspec();
    static NAN_METHOD(From);
    static NAN_METHOD(To);
    static NAN_METHOD(Flags);
};

#endif
