// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITTIME_H
#define GITTIME_H
#include <nan.h>
#include <string>
#include <utility>
#include <sstream>

#include "async_baton.h"
#include "async_worker.h"
#include "cleanup_handle.h"
#include "context.h"
#include "lock_master.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"


using namespace node;
using namespace v8;

class GitTime;
 
struct GitTimeTraits {
  typedef GitTime cppClass;
  typedef git_time cType;
 
  static const bool isDuplicable = true;
  static void duplicate(git_time **dest, git_time *src) {
    git_time_dup(dest, src);
   }

  static std::string className() { return "GitTime"; };
  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_time *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitTime : public
  NodeGitWrapper<GitTimeTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitTimeTraits>;
   public:
    GitTime(const GitTime &) = delete;
    GitTime(GitTime &&) = delete;
    GitTime &operator=(const GitTime &) = delete;
    GitTime &operator=(GitTime &&) = delete;

    static void InitializeComponent (v8::Local<v8::Object> target, nodegit::Context *nodegitContext);

 

  private:
    GitTime()
      : NodeGitWrapper<GitTimeTraits>(
           "A new GitTime cannot be instantiated."
       )
    {}
    GitTime(git_time *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitTimeTraits>(raw, selfFreeing, owner)
    {}
    ~GitTime();
    static NAN_METHOD(Time);
    static NAN_METHOD(Offset);
    static NAN_METHOD(Sign);
};

#endif
