// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITTRANSACTION_H
#define GITTRANSACTION_H
#include <nan.h>
#include <string>
#include <utility>
#include <sstream>

#include "async_baton.h"
#include "async_worker.h"
#include "cleanup_handle.h"
#include "context.h"
#include "lock_master.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"

#include "../include/repository.h"
#include "../include/reflog.h"
#include "../include/signature.h"
#include "../include/oid.h"
// Forward declaration.
struct git_transaction {
};

using namespace node;
using namespace v8;

class GitTransaction;
 
struct GitTransactionTraits {
  typedef GitTransaction cppClass;
  typedef git_transaction cType;
 
  static const bool isDuplicable = false;
  static void duplicate(git_transaction **dest, git_transaction *src) {
     Nan::ThrowError("duplicate called on GitTransaction which cannot be duplicated");
   }

  static std::string className() { return "GitTransaction"; };
  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_transaction *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::git_transaction_free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitTransaction : public
  NodeGitWrapper<GitTransactionTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitTransactionTraits>;
   public:
    GitTransaction(const GitTransaction &) = delete;
    GitTransaction(GitTransaction &&) = delete;
    GitTransaction &operator=(const GitTransaction &) = delete;
    GitTransaction &operator=(GitTransaction &&) = delete;

    static void InitializeComponent (v8::Local<v8::Object> target, nodegit::Context *nodegitContext);

                                   

  private:
    GitTransaction()
      : NodeGitWrapper<GitTransactionTraits>(
           "A new GitTransaction cannot be instantiated."
       )
    {}
    GitTransaction(git_transaction *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitTransactionTraits>(raw, selfFreeing, owner)
    {}
    ~GitTransaction();

    static NAN_METHOD(Commit);

    static NAN_METHOD(LockRef);

    struct CreateBaton {
      int error_code;
      const git_error* error;
      git_transaction * out;
      git_repository * repo;
     };
    class CreateWorker : public nodegit::AsyncWorker {
      public:
        CreateWorker(
            CreateBaton *_baton,
            Nan::Callback *callback,
            std::map<std::string, std::shared_ptr<nodegit::CleanupHandle>> &cleanupHandles
        ) : nodegit::AsyncWorker(callback, "nodegit:AsyncWorker:GitTransaction:Create", cleanupHandles)
          , baton(_baton) {};
        CreateWorker(const CreateWorker &) = delete;
        CreateWorker(CreateWorker &&) = delete;
        CreateWorker &operator=(const CreateWorker &) = delete;
        CreateWorker &operator=(CreateWorker &&) = delete;
        ~CreateWorker() {};
        void Execute();
        void HandleErrorCallback();
        void HandleOKCallback();
        nodegit::LockMaster AcquireLocks();

      private:
        CreateBaton *baton;
    };

    static NAN_METHOD(Create);

    static NAN_METHOD(Remove);

    static NAN_METHOD(SetReflog);

    static NAN_METHOD(SetSymbolicTarget);

    static NAN_METHOD(SetTarget);
};

#endif
