// This is a generated file, modify: generate/templates/templates/struct_content.cc

// generated from struct_content.cc
#include <nan.h>
#include <string.h>
#ifdef WIN32
#include <windows.h>
#else
#include <unistd.h>
#endif // win32

extern "C" {
  #include <git2.h>
 }

#include <iostream>
#include "../include/nodegit.h"
#include "../include/lock_master.h"
#include "../include/functions/copy.h"
#include "../include/remote_create_options.h"
#include "nodegit_wrapper.cc"

  #include "../include/repository.h"
 
using namespace v8;
using namespace node;
using namespace std;

 
ConfigurableGitRemoteCreateOptions::ConfigurableGitRemoteCreateOptions(nodegit::Context *nodegitContext)
  : nodegit::ConfigurableClassWrapper<GitRemoteCreateOptionsTraits>(nodegitContext)
{
     git_remote_create_options  wrappedValue = GIT_REMOTE_CREATE_OPTIONS_INIT;
    this->raw = (git_remote_create_options*) malloc(sizeof(git_remote_create_options ));
    memcpy(this->raw, &wrappedValue, sizeof(git_remote_create_options ));
 }

ConfigurableGitRemoteCreateOptions::~ConfigurableGitRemoteCreateOptions() {
            delete this->raw->name;
          delete this->raw->fetchspec;
     }

nodegit::ConfigurableClassWrapper<GitRemoteCreateOptionsTraits>::v8ConversionResult ConfigurableGitRemoteCreateOptions::fromJavascript(nodegit::Context *nodegitContext, v8::Local<v8::Value> input) {
  if (!input->IsObject()) {
    return {
      "Must pass object for ConfigurableGitRemoteCreateOptions"
    };
  }

  Nan::HandleScope scope;
  v8::Local<v8::Object> inputObj = input.As<v8::Object>();
  std::shared_ptr<ConfigurableGitRemoteCreateOptions> output(new ConfigurableGitRemoteCreateOptions(nodegitContext));

  // unpack the data into the correct fields
         {
          v8::Local<v8::Value> maybeNumber = nodegit::safeGetField(inputObj, "version");
          if (!maybeNumber.IsEmpty() && !maybeNumber->IsUndefined() && !maybeNumber->IsNull()) {
            if (!maybeNumber->IsNumber()) {
              return {
                "Must pass Int32 to version"
              };
            }

            output->raw->version = static_cast<unsigned int>(maybeNumber->Int32Value(Nan::GetCurrentContext()).FromJust());
          }
        }
             {
            v8::Local<v8::Value> maybeObject = nodegit::safeGetField(inputObj, "repository");
            if (!maybeObject.IsEmpty() && !maybeObject->IsUndefined() && !maybeObject->IsNull()) {
              if (!maybeObject->IsObject()) {
                return {
                  "Must pass NodeGit.Repository to repository"
                };
              }

              v8::Local<v8::Object> objectValue = maybeObject.As<v8::Object>();
              output->raw->repository = Nan::ObjectWrap::Unwrap<GitRepository>(objectValue)->GetValue();
              output->repository.Reset(objectValue);
            }
          }
           output->raw->name = nullptr;
        {
          v8::Local<v8::Value> maybeString = nodegit::safeGetField(inputObj, "name");
          if (!maybeString.IsEmpty() && !maybeString->IsUndefined() && !maybeString->IsNull()) {
            if (!maybeString->IsString()) {
              return {
                "Must pass string to name"
              };
            }

            Nan::Utf8String utf8String(maybeString.As<v8::String>());
            output->raw->name = strdup(*utf8String);
          }
        }
          output->raw->fetchspec = nullptr;
        {
          v8::Local<v8::Value> maybeString = nodegit::safeGetField(inputObj, "fetchspec");
          if (!maybeString.IsEmpty() && !maybeString->IsUndefined() && !maybeString->IsNull()) {
            if (!maybeString->IsString()) {
              return {
                "Must pass string to fetchspec"
              };
            }

            Nan::Utf8String utf8String(maybeString.As<v8::String>());
            output->raw->fetchspec = strdup(*utf8String);
          }
        }
           {
          v8::Local<v8::Value> maybeNumber = nodegit::safeGetField(inputObj, "flags");
          if (!maybeNumber.IsEmpty() && !maybeNumber->IsUndefined() && !maybeNumber->IsNull()) {
            if (!maybeNumber->IsNumber()) {
              return {
                "Must pass Int32 to flags"
              };
            }

            output->raw->flags = static_cast<unsigned int>(maybeNumber->Int32Value(Nan::GetCurrentContext()).FromJust());
          }
        }
    
  return {
    output
  };
}

           
// force base class template instantiation, to make sure we get all the
// methods, statics, etc.
template class nodegit::ConfigurableClassWrapper<GitRemoteCreateOptionsTraits>;
